/****************************************************************************************************

		I3DExTimeDependentPrimitive.h
		Copyright: (c) 2001 Eovia Corp. All rights reserved.

		Author:	Charles
		Date:	8/27/2002

****************************************************************************************************/

#ifndef __I3DExTimeDependentPrimitive__
#define __I3DExTimeDependentPrimitive__

#if CP_PRAGMA_ONCE
#pragma once
#endif

#include "IExtension.h"
#include "InterfaceIDs.h"



MCDEFINE_GUID_H(IID_I3DExTimeDependentPrimitive);

/// \addtogroup ExternalInterface
/// \{

/// A primitive that derives from this interface will be called by the Shell every time
/// the time is changed. This is useful if you want to make a primitive that depends
/// on the time without using animated parameters.
///
struct I3DExTimeDependentPrimitive: public IMCUnknown
{
	///	Returns true if the primitive needs to be updated (called by the shell when the time changed).
	///
	virtual boolean	   MCCOMAPI PrimitiveChanged() = 0;
};

/// \}


#endif
